Package com.google.protobuf

## Enum DescriptorProtos.FieldDescriptorProto.Label

- java.lang.Object
- - java.lang.Enum<DescriptorProtos.FieldDescriptorProto.Label>
  - - com.google.protobuf.DescriptorProtos.FieldDescriptorProto.Label

All Implemented Interfaces:
  `Internal.EnumLite`, `ProtocolMessageEnum`, `java.io.Serializable`, `java.lang.Comparable<DescriptorProtos.FieldDescriptorProto.Label>`

Enclosing class:
  DescriptorProtos.FieldDescriptorProto

    public static enum DescriptorProtos.FieldDescriptorProto.Label
    extends java.lang.Enum<DescriptorProtos.FieldDescriptorProto.Label>
    implements ProtocolMessageEnum

Protobuf enum `google.protobuf.FieldDescriptorProto.Label`

### Enum Constant Summary

Enum Constants
`LABEL_OPTIONAL` `LABEL_OPTIONAL = 1;`
`LABEL_REPEATED` `LABEL_REPEATED = 3;`
`LABEL_REQUIRED` `LABEL_REQUIRED = 2;`

### Field Summary

Fields
`static int` `LABEL_OPTIONAL_VALUE` `LABEL_OPTIONAL = 1;`
`static int` `LABEL_REPEATED_VALUE` `LABEL_REPEATED = 3;`
`static int` `LABEL_REQUIRED_VALUE` `LABEL_REQUIRED = 2;`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static Descriptors.EnumDescriptor` `getDescriptor()`
`Descriptors.EnumDescriptor` `getDescriptorForType()` Return the enum type's descriptor, which contains information about each defined value, etc.
`int` `getNumber()` Return the value's numeric value as defined in the .proto file.
`Descriptors.EnumValueDescriptor` `getValueDescriptor()` Return the value's descriptor, which contains information such as value name, number, and type.
`static Internal.EnumLiteMap<DescriptorProtos.FieldDescriptorProto.Label>` `internalGetValueMap()`
`static DescriptorProtos.FieldDescriptorProto.Label` `valueOf​(int value)` Returns the enum constant of this type with the specified name.
`static DescriptorProtos.FieldDescriptorProto.Label` `valueOf​(Descriptors.EnumValueDescriptor desc)` Returns the enum constant of this type with the specified name.
`static DescriptorProtos.FieldDescriptorProto.Label` `valueOf​(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static DescriptorProtos.FieldDescriptorProto.Label[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### LABEL_OPTIONAL

    public static final DescriptorProtos.FieldDescriptorProto.Label LABEL_OPTIONAL

`LABEL_OPTIONAL = 1;`

     0 is reserved for errors

#### LABEL_REQUIRED

    public static final DescriptorProtos.FieldDescriptorProto.Label LABEL_REQUIRED

`LABEL_REQUIRED = 2;`

#### LABEL_REPEATED

    public static final DescriptorProtos.FieldDescriptorProto.Label LABEL_REPEATED

`LABEL_REPEATED = 3;`

     TODO(sanjay): Should we add LABEL_MAP?

### Field Detail

#### LABEL_OPTIONAL_VALUE

    public static final int LABEL_OPTIONAL_VALUE

`LABEL_OPTIONAL = 1;`

     0 is reserved for errors

See Also:
  Constant Field Values

#### LABEL_REQUIRED_VALUE

    public static final int LABEL_REQUIRED_VALUE

`LABEL_REQUIRED = 2;`

See Also:
  Constant Field Values

#### LABEL_REPEATED_VALUE

    public static final int LABEL_REPEATED_VALUE

`LABEL_REPEATED = 3;`

     TODO(sanjay): Should we add LABEL_MAP?

See Also:
  Constant Field Values

### Method Detail

#### values

    public static DescriptorProtos.FieldDescriptorProto.Label[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (DescriptorProtos.FieldDescriptorProto.Label c : DescriptorProtos.FieldDescriptorProto.Label.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static DescriptorProtos.FieldDescriptorProto.Label valueOf​(java.lang.String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null

#### getNumber

    public final int getNumber()

Description copied from interface: `ProtocolMessageEnum`
Return the value's numeric value as defined in the .proto file.

Specified by:
  `getNumber` in interface `Internal.EnumLite`
Specified by:
  `getNumber` in interface `ProtocolMessageEnum`

#### valueOf

    public static DescriptorProtos.FieldDescriptorProto.Label valueOf​(int value)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `value` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null

#### internalGetValueMap

    public static Internal.EnumLiteMap<DescriptorProtos.FieldDescriptorProto.Label> internalGetValueMap()

#### getValueDescriptor

    public final Descriptors.EnumValueDescriptor getValueDescriptor()

Description copied from interface: `ProtocolMessageEnum`
Return the value's descriptor, which contains information such as value name, number, and type.

Specified by:
  `getValueDescriptor` in interface `ProtocolMessageEnum`

#### getDescriptorForType

    public final Descriptors.EnumDescriptor getDescriptorForType()

Description copied from interface: `ProtocolMessageEnum`
Return the enum type's descriptor, which contains information about each defined value, etc.

Specified by:
  `getDescriptorForType` in interface `ProtocolMessageEnum`

#### getDescriptor

    public static final Descriptors.EnumDescriptor getDescriptor()

#### valueOf

    public static DescriptorProtos.FieldDescriptorProto.Label valueOf​(Descriptors.EnumValueDescriptor desc)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `desc` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null